﻿using Infragistics.Win.Printing;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.Drawing.Printing;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace _149281
{
    public class MultiPrintDocument : UltraPrintDocument
    {
        private PrintDocument[] _documents;
        private int _docIndex;
        private PrintEventArgs _args;
        //private int total = 0;
        //PrintController printController = new StandardPrintController();

        // constructors
        public MultiPrintDocument(PrintDocument document1, PrintDocument document2)
        {
            _documents = new PrintDocument[] { document1, document2 };
            
        }

        public MultiPrintDocument(PrintDocument[] documents)
        {
            _documents = documents;
            //foreach (PrintDocument doc in documents)
            //{
            //    var controloer = doc.PrintController;
            //    doc.PrintController = printController;
            //    doc.PrintPage += doc_PrintPage;
            //    doc.Print();
            //    doc.PrintPage -= doc_PrintPage;
            //    doc.PrintController = controloer;
            //}
        }

        //void doc_PrintPage(object sender, PrintPageEventArgs e)
        //{
        //    total++;
        //}

        // overidden methods
        protected override void OnBeginPrint(PrintEventArgs e)
        {
            base.OnBeginPrint(e); 
            e.Cancel = false;
            if (_documents.Length == 0)
                e.Cancel = true;
               
           if (e.Cancel) return;

           //if (this.Footer.TextCenter != null)
           //    this.Footer.TextCenter = this.Footer.TextCenter.Replace("[Total ##]", total.ToString());
           //if (this.Footer.TextLeft != null)
           //    this.Footer.TextLeft = this.Footer.TextLeft.Replace("[Total ##]", total.ToString());
           //if (this.Footer.TextRight != null)
           //    this.Footer.TextRight = this.Footer.TextRight.Replace("[Total ##]", total.ToString());

            _args = e;
            _docIndex = 0;  // reset current document index
            CallMethod(_documents[_docIndex], "OnBeginPrint", e);
        }

        protected override void OnQueryPageSettings(QueryPageSettingsEventArgs e)
        {
            e.PageSettings = _documents[_docIndex].DefaultPageSettings;
            CallMethod(_documents[_docIndex], "OnQueryPageSettings", e);
            base.OnQueryPageSettings(e);
        }

        protected override void OnPrintPage(PrintPageEventArgs e)
        {
            CallMethod(_documents[_docIndex], "OnPrintPage", e);
            bool hasMorePages = e.HasMorePages;
            base.OnPrintPage(e);
            e.HasMorePages = hasMorePages;
            if (e.Cancel) return;
            if (!e.HasMorePages)
            {
                CallMethod(_documents[_docIndex], "OnEndPrint", _args);
                if (_args.Cancel) return;
                _docIndex++;  // increments the current document index

                if (_docIndex < _documents.Length)
                {
                    // says that it has more pages (in others documents)
                    e.HasMorePages = true;
                    CallMethod(_documents[_docIndex], "OnBeginPrint", _args);
                }
            }
        }

        // use reflection to call protected methods of child documents
        private void CallMethod(PrintDocument document, string methodName, object args)
        {
            typeof(PrintDocument).InvokeMember(methodName,
              BindingFlags.InvokeMethod | BindingFlags.Instance | BindingFlags.NonPublic,
              null, document, new object[] { args });
        }
    }



}
